
\newpage
\section{Practical works}
Now, you have basic knowledge of Python programming techniques. You
must train yourself to improve your skills.

\subsection{Guess the number game}
\newexo{language basics}{15 min}{Implement the guess the number game}{guess-the-number.py}

This exercise consists in programmings the
\textit{guess-the-number} game.

\begin{task}
  randomly choose an integer number in [0,100] range. 
  You can use the \keyw{random} module.
\end{task}


\begin{task}
  ask users to give a number in this range. If
  input is out-of-range, you must specify it.
\end{task}

\begin{task}
  program must tell to users if the entry is lower or higher than
  the random hidden number.
\end{task}

\begin{task}
  program stops if users guess the right number.
\end{task}

The output must look like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
give a number: 50
your entry is lower than hidden number
give a number: 75
your entry is higher than hidden number
give a number: 60
your entry is higher than hidden number
give a number: 55
your entry is lower than hidden number
give a number: 57
your entry is lower than hidden number
give a number: 58
your entry is lower than hidden number
give a number: 59
You guess the number. The mystery number was '59'
\end{lstlisting}
You can improve your program by using a maximal number of tentative.






\newpage
\subsection{The hangman game}
\newexo{language basics}{30 min}{Implement the hangman game}{hangman.py}

The goal of this game is to guess a mystery word.

\begin{task}
  randomly choose a mystery word in a given word list.
\end{task}

\begin{task}
  ask users to give a character.
\end{task}

\begin{task}
  if the given character is in the word, the related character must be revealed.
\end{task}

\begin{task}
  the game ends if the word is completely revealed.
\end{task}

\noindent The outputs of your program must looks like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
current word is '['_', '_', '_', '_', '_']'
give a character: l

current word is '['_', '_', 'l', 'l', '_']'
give a character: h

current word is '['h', '_', 'l', 'l', '_']'
give a character: e

current word is '['h', 'e', 'l', 'l', '_']'
give a character: o

YOU WIN !!
The mystery word was 'hello'
\end{lstlisting}



\newpage
\subsection{Hacking image files}
\newexo{language basics and reading/writing files}{1 hour}{Extract hidden information from image files}
{read-img/read-img.py}


The objective of this training exercise is to extract some interesting
meta-data from image files. Note that this exercise is inspired from a
real case!  First, you have to download the following archive
\url{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/read-img/img.zip}
that contains several image files. These images were given by Scanning
Electron Microscope on a Al2TiO5 material. These images look like:
\begin{center}\includegraphics[width=.7\linewidth]{./img/sem}\end{center}



If you take a look at these images, you can see at the bottom some
useful information: magnitude, pressure, temperature and so on... In
fact, these information are hidden inside the files.  Open with a
\textbf{text editor} one of these image files and take a look at the
end of the file. What did you observe?


\begin{task}
  write a script that reads an image file line by line in the ascii format
  and that displays the result with the \texttt{print()} function. To avoid
  any error while reading files, you can set the optional argument
  \keyw{errors} to the \keyw{'ignore'} value of the \keyw{open(...)}
  built-in function as it follows: \vspace*{-1\baselineskip}
\begin{lstlisting}
open('yourfile', 'r', encoding='ascii', errors='ignore') # for python3
\end{lstlisting}

\begin{attention}
  Be aware, with python2, you must do
  \vspace*{-1\baselineskip}
  \begin{lstlisting}
    open('yourfile', 'rb')
  \end{lstlisting}
\end{attention}
\end{task}

\begin{task}
  thanks to a condition, build a filter that displays only the lines
  that contain the temperature and the pressure in the vacuum chamber.
\end{task}

\begin{task}
  thanks to the \texttt{replace()} method of the \texttt{str} class,
  extract the temperature and pressure and convert as floating numbers.
\end{task}

Imagine that you have a huge number of images. in order to build a global
image database, you want to extract all these information.

\begin{task}
  extract, for each image file, the related temperature and
  pressure. Store these information in a dictionary, lists or tuples . To parse 
  all files in a given directory, you can use the \keyw{glob} module as this:
\vspace*{-1\baselineskip}
\begin{lstlisting}
import glob
for filename in glob.glob('*.tif'):
   print filename
   # do your stuff here
\end{lstlisting}
\end{task}

\begin{task}
  Plot, with 2 bar diagrams, the evolution of temperature and pressure related to image files.
  These diagrams must look like: 
  \begin{center}
  \includegraphics[width=1.0\linewidth]{histo-img}
\end{center}
\end{task}


Suppose that we want to build a database file that provides, for each
given file, the related temperature and pressure. A naive
implementation of this database may look like: 
\vspace*{-1\baselineskip}
\begin{lstlisting}
Filename        Temperature        Pressure     
xxxxx.tif       xxxx               xxxxx
xxxxx.tif       xxxx               xxxxx
...§\mylabel{img.db}§
\end{lstlisting}

\begin{task}
  from the above listing, build a script that automatically write 
  this database. You could name this database ``\texttt{img.db}''.
\end{task}

Now, we would like to use a more advanced file format. A popular
format for this kind of little database is the \textit{json}
format that looks like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
{
  "img/Fissuration-TiAl2O5__036_-_01542.tif": {
    "temperature": 1070.18,
    "pressure": 99.6605
  },
  "img/Fissuration-TiAl2O5__036_-_01491.tif": {
    "temperature": 1101.76,
    "pressure": 100.042
  },
  "img/Fissuration-TiAl2O5__036_-_01541.tif": {
    "temperature": 1072.74,
    "pressure": 100.042
  },
  "img/Fissuration-TiAl2O5__036_-_01490.tif": {
    "temperature": 1102.57,
    "pressure": 100.423
  }
}§\mylabel{img.json}§
\end{lstlisting}

\begin{task}
  with the \texttt{json} module, able to dump the content of a python dictionary,
  build a script that writes this json file automatically.
\end{task}


\newpage
\subsection{Legacy function vs universal function (ufunc)}
\newexo{language basics, numpy}{20 min}{Universal function benchmark}{bench-ufunc.py}

The goal of this exercise is to benchmark a legacy function versus a numpy universal function (ufunc).

\begin{task}
  thanks to the \texttt{np.arange} function, build an array \texttt{x} that contains $10^7$ elements.
\end{task}


\begin{task}
  implement a legacy function \texttt{sin\_py()} that:
\begin{itemize}
\item takes as argument the \texttt{x} array
\item returns a numpy array that contains the sinus of each element 
\end{itemize}
\end{task}

\begin{task}
  execute this function for the \texttt{x} array. Monitor the elapsed time thanks to the \texttt{time} module.
\end{task}

\begin{task}
  execute the  \texttt{np.sin()} ufunction. 
\end{task}

Your output should give something like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
elapsed time for sin_py(x) is 1.7576186656951904 s
elapsed time for np.sin(x) is 0.17843055725097656 s
\end{lstlisting}



\newpage
\subsection{Post-treating student rating}
\newexo{language basics, numpy}{20 min}{Quick statistical treatment}{grading.py}

This exercise highlights numpy array methods. Here, the data comes from student rating.

\begin{task}
  thanks to the \texttt{np.random.normal}, generate an array of 500 values in the [0,20] range corresponding to student rating.
\end{task}

\begin{task}
  thanks to numpy array methods, compute the following data: student number (must be 500), max value, min value, mean value, standard deviation value, cumulative summation, number of student higher than 15 and sorted values.
\end{task}

Your output should give something like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
rating number                  ; 500
min value                      : 6.017527039633518
max value                      : 17.79272432969885
mean value                     : 12.04497827181669
standard dev                   : 1.9866937935737548
cumulative sum                 : 6022.489135908345
number of values higher than 15: 34
sorted rating  [ 6.99550988  7.5029463   7.76531536  ... 18.06266806]
\end{lstlisting}

\begin{task}
  plot the related histogram in the [0,20] range with 10 classes.  
\end{task}

You must obtain something like this.
\begin{center}
  \includegraphics[width=1.\linewidth]{rating}
\end{center}



\newpage
\subsection{The bouncing ball}
\newexo{language basics, numpy, matplotlib}{60 minutes}{Post-treat mechanical data}{bouncing-ball.py}

The objective is to extract, post-treat and plot data which were generated by a simulation. You can
take a look on the simulation here \dl{bouncing-ball.mp4}, this is just a ball that rebounds on the ground.
Now, download the data file \dl{bouncing-ball.txt} generated by this simulation. As you can see, the data
file contains three columns :
\begin{enumerate}
\item the current elapsed time in seconds,
\item the current position of the ball along the x axis (horizontal coordinates) in meters
\item the current position of the ball along the y axis (vertical coordinates) in meters
\end{enumerate}

Here you can see the header of this data file.
 \vspace*{-1\baselineskip}
\begin{lstlisting}
# time (s)     # positionX (m)       # positionY (m)
0.0            10.04                 79.99984304
0.16           11.639999999999965    79.86485743999998
0.32           13.239999999999931    79.47873583999998
0.48           14.839999999999897    78.84147824
...
\end{lstlisting}

\begin{task}
  Extract the data thanks to the \texttt{loadtxt()} function of the \texttt{numpy} module.
  Store each column of the data file into numpy array. You can use the following code snippet.
  \vspace*{-1\baselineskip}
\begin{lstlisting}
import numpy as np    
t, p_x, p_y = np.loadtxt("./bouncing-ball.txt", delimiter='\t', usecols=(0, 1, 2), unpack=True)
\end{lstlisting}
\end{task}


\begin{task}
  Plot the following curves :
  \begin{enumerate}
  \item evolution of the horizontal ball position versus time 
  \item evolution of the vertical ball position versus time 
  \end{enumerate}
  Add the axis labels and title. 
\end{task}

You should obtain something like this.
  \begin{center}
  \includegraphics[width=0.4\linewidth]{img/bouncing-ball_1.pdf}
\end{center}

\begin{task}
  Plot the ball trajectory. Add the axis labels and title. Use circle markers instead of line plot.
\end{task}
You should obtain something like this.
  \begin{center}
  \includegraphics[width=0.4\linewidth]{img/bouncing-ball_2.pdf}
\end{center}

As you can see, the above plot does not respect aspect ratio.
\begin{task}
  Thanks to the following code snippet :
   \vspace*{-1\baselineskip}
\begin{lstlisting}
plt.gca().set_aspect('equal', adjustable='box')
\end{lstlisting}
adjust the aspect ratio. Set also the limits of the X and Y axes as :
\begin{enumerate}
\item [0,500] for the horizontal axis
\item [0,100] for the vertical axis
\end{enumerate}
\end{task}
You should obtain something like this.
  \begin{center}
  \includegraphics[width=0.9\linewidth]{img/bouncing-ball_3.pdf}
\end{center}

\begin{task}
  Thanks the \texttt{gradient()} function of the \texttt{numpy} module, computes the horizontal and the vertical velocities.
\end{task}

\begin{task}
  Thanks the \texttt{arrow()} function of the \texttt{matplotlib} modudle, display for each markers the instantaneous velocities.
\end{task}

You should obtain something like this.
  \begin{center}
  \includegraphics[width=0.9\linewidth]{img/bouncing-ball_4.pdf}
\end{center}

\begin{info}
  The next part is only if you have time and if you want to go further...
\end{info}

Considering the following parameters for the simulation :
\begin{itemize}
\item gravity $\vec{g}=\begin{bmatrix}0 \\ -9.81\end{bmatrix}$
\item initial ball position $\vec{p}(0)=\begin{bmatrix}10 \\ 80\end{bmatrix}$
\item initial ball velocity $\vec{v}(0)=\begin{bmatrix}10 \\ 0\end{bmatrix}$
\end{itemize}

\begin{task}
  By applying the second Newton's law for the considered parameters, prove that the equation of motion is given by :
  \begin{equation}
    \vec{p}(t) = \begin{bmatrix}10 t + 10 \\ -\frac{1}{2}\times 9.81 \times t^{2} + 80\end{bmatrix}\nonumber
  \end{equation}
\end{task}

\begin{task}
  Apply these formula to predict the motion of the ball before its
  first bouncing. Store the results in two numpy array \texttt{p\_xa}
  and \texttt{p\_ya} (note that you should use the \texttt{t} parameter
  (see task 1.).
\end{task}

\begin{task}
  Plot the results and compare them to the simulation.
\end{task}

You should obtain something like this.
  \begin{center}
  \includegraphics[width=0.4\linewidth]{img/bouncing-ball_5.pdf}
\end{center}



\newpage
\subsection{Summation function evaluation}
\newexo{language basics, numpy, matplotlib}{10 minutes}{Compute a summation function}{sum.py}

The objective is simple: compute and plot the following function in
the $[-\frac{\pi}{2}; \frac{\pi}{2}]$ range

\begin{equation}
  f(x) = \sum_{q=1}^{100} \text{cos}(qx)\nonumber
\end{equation}






\newpage
\subsection{Simple gaussian function}
\newexo{language basics, numpy, matplotlib}{10 minutes}{Display gaussian function}{gauss.py}

The objective is simple: compute and plot the following gaussian function in
the $[0; 1]$ range for several value of the $K$ factor.

\begin{equation}
  f(x) = e^{-\left(\frac{x-0.5}{K}\right)^2}\nonumber
\end{equation}

You must obtain something like this:
\begin{center}
  \includegraphics[width=0.6\linewidth]{gauss}
\end{center}





\newpage
\subsection{2D gaussian function and image}
\newexo{language basics, numpy, matplotlib}{10 minutes}{}{gauss-2D.py}

The objective of this training exercise is to create an artificial
image from a 2D function. Here, we will use the gaussian function
given by:
\begin{equation}
  g(x) = \frac{1}{\sigma\sqrt{2\pi}} e^{-\frac{1}{2}\left(\frac{x-\mu}{\sigma}\right)^2}
\end{equation}
where $\sigma$ is the standard deviation and $\mu$ the mean of the
related statistical distribution.


\begin{task}
  Implement the \texttt{gauss} function . This function should returns a numpy array. The
  prototype of this functions should be:
  \vspace*{-1\baselineskip}
  \begin{lstlisting}
def gauss(x, mu, sigma):
    ...
  \end{lstlisting}
\end{task}

Now, we will implement a 2D version of the gaussian function:
\begin{equation}
  G(x,y) = g_{1}(x) \times g_{2}(y) 
\end{equation}

\begin{task}
  Copy/paste the following code that implements the \texttt{gauss\_2D} function . 
  \vspace*{-1\baselineskip}
  \begin{lstlisting}
def gauss_2D(x, y, mux, muy, sigx, sigy):
    return gauss(x,mux,sigx)*gauss(y,muy,sigy)
\end{lstlisting}
\end{task}

\begin{task}
  Thanks to the \texttt{numpy.arange} function, build two arrays \texttt{x} and \texttt{y}
\end{task}


\begin{task}
  Use the \texttt{gauss\_2D} function for computing a 2D array from
  \texttt{x} and \texttt{y}. Take care about the \texttt{x} and
  \texttt{y} shape!
\end{task}

\begin{task}
  Plot the result with the \texttt{plt.imshow} function
\end{task}

You must obtain something like this:
\begin{center}
  \includegraphics[width=0.4\linewidth]{img/gauss-2D.pdf}
\end{center}




\newpage
\subsection{Linear regression with least square method}
\newexo{language basics, numpy, scipy, matplotlib}{10 minutes}{}{lsq.py}

The objective of this training exercise it to implement a least square
regression for fitting data with a linear function.

\begin{task}
  Download the data \dl{lsq.txt} and place it on your current python working directory.
  Read this data file using the following code snippet:
  \vspace*{-1\baselineskip}
  \begin{lstlisting}
x,y = np.loadtxt("lsq.txt", unpack = True)
\end{lstlisting}
\end{task}

\begin{task}
  Plot the \texttt{x} array versus the \texttt{y} array
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.6\linewidth]{img/lsq-1.pdf}
\end{center}

\begin{task}
  Implement a linear function. The prototype should be:
  \vspace*{-1\baselineskip}
  \begin{lstlisting}
def linear_func(x, a, b):
   ...
\end{lstlisting}
\end{task}


\begin{task}
  Use the \texttt{optimize.curve\_fit} function that comes
  from the \texttt{scipy.optimize} module to get best fit values of the
  \texttt{a} (slope) and \texttt{b} (intercept) coefficients of the \texttt{linear\_func}
\end{task}


\begin{task}
  Plot on the same graph the best fit curve and the data points.
\end{task}

You must obtain something like this:
\begin{center}
  \includegraphics[width=0.6\linewidth]{img/lsq-2.pdf}
\end{center}


\newpage
\subsection{Post-treating X-ray diffraction raw data}
\newexo{language basics, i/o, numpy, scipy, matplotlib}{1.5 hours}{}{drx.py}

The objective of this exercise it to post-treat experimental data that
comes from x-ray diffraction. Here the objective is to measure very
precisely the shifting of a given peak of different sample.

\begin{task}
  Download the data \dl{drx-sample1.xy}, \dl{drx-sample2.xy},
  \dl{drx-sample3.xy}, \dl{drx-sample4.xy} and \dl{drx-sample5.xy} and
  place them on your current python working directory. Read these data
  with your favorite text editor.
\end{task}

\begin{task}
  Open the first file and push data in \texttt{numpy.array} for plotting X-ray diffraction diagram.
  You should obtain something like.
  \begin{center}
    \includegraphics[width=1.\linewidth]{img/drx.pdf}
  \end{center}
\end{task}


\begin{task}
  Crop the data in the [23, 24.5] degree range to focus on the first peak.
\end{task}


\begin{task}
  Following the mathematical definition of a gaussian function :
  \begin{equation}
    g(x) = K + \frac{A}{\sigma\sqrt{2\pi}}e^{-\frac{1}{2}\left(\frac{x-\mu}{\sigma}\right)^2}\nonumber
  \end{equation}
  implement a function named \texttt{gauss(x,mu,sigma,A,K)} that takes $x$, $\mu$,
  $\sigma$ ,$A$ and $K$ as arguments and returns the values of $g(x)$. 
\end{task}


\begin{task}
  Use the \texttt{curve\_fit} function that comes from the
  \texttt{scipy.optimize} module for computing best fit values of the
  $x$, $\mu$, $\sigma$ ,$A$ and $K$ values. From these results, deduce
  the position of the peak.
\end{task}

\begin{task}
  Automatize this process for all the x-ray diffraction files and
  display x-ray diagrams on a same figure with the \texttt{subplot}
  function. In addition, you should display on each diagram :
  \begin{enumerate}
  \item the file name
  \item the position angle of the first peak computed with the fitting function
  \item vertical lines that highlights the peak positions 
  \end{enumerate}
\end{task}




\newpage
\subsection{Playing with image}
\newexo{language basics, numpy, matplotlib}{1-hour}{Use numpy for manipulating images}{cow.py}

The objective is to use numpy for manipulating images: color to gray scale conversion, crop, saturating, etc.
We will play with the above image.
\begin{center}
  \includegraphics[width=0.6\linewidth]{img/cow.png}
\end{center}



\begin{task}
  Download the image file \dl{cow.png} and place it on your current python working directory.
\end{task}

\begin{task}
  Thanks to the \texttt{mpimg} module that comes from
  \texttt{matplotlib.image}, open the image and plot it with
  the \texttt{imshow} function.
\end{task}

At this step, you should have an \texttt{img} numpy array that
describes the image in the Red Green Blue (RGB) image format.

\begin{task}
  To learn more about the image and the RGB format, print the shape of the image array,  the
  min and max values. You should obtain something like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
image shape    : (1137, 1820, 3)
image min value: 0.0
image max value: 1.0
\end{lstlisting}
\end{task}

From the above information the image is 1137$\times$1820 pixels and
contains 3 channels related to the three colors: red, green and blue
also named \textit{channel}. \texttt{0} corresponds to no-color and \texttt{1}
corresponds to the maximal color intensity. Each channel accepts values
in the [0, 1] range.  Now, we will move on black and white image. Black
and white images are simpler because they contain only one channel:
the gray scale channel in the [0,1] range. We will use the following
function for grayscale conversion that takes in argument an rgb numpy
array and returns a numpy array that describes the image in grayscale.

\vspace*{-1\baselineskip}
\begin{lstlisting}
def rgb2gray(rgb_im):
    r, g, b = rgb_im[:,:,0], rgb_im[:,:,1], rgb_im[:,:,2]
    gray_im = 0.2989 * r + 0.5870 * g + 0.1140 * b
    return gray_im
\end{lstlisting}


\begin{task}
  Thanks to the \texttt{imshow} function, plot the related image
  converted in grayscale.  You must use the
  \texttt{cmap=plt.get\_cmap('gray')} optional argument to plot it in
  grayscale.
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-gray.png}
\end{center}


\begin{task}
  Thanks to slicing, zoom on the area highlighted below.
  \begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-zone.png}
\end{center}
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-zoom.png}
\end{center}


\begin{task}
  Thanks to numpy filter, saturates the image. Pixels lower than 0.5
  must take the zero value or one otherwise.
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-sat.png}
\end{center}


\begin{task}
  Thanks to the numpy transpose function \texttt{.T}, make a 90$^\circ$ rotation
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-rot.png}
\end{center}


\begin{task}
  Make a copy of the image and crop the working area.
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-crop.png}
\end{center}


\begin{task}
  Finally, try to hide the working area of the image
\end{task}

You should obtain something like this:
\begin{center}
  \includegraphics[width=0.8\linewidth]{img/cow-hide.png}
\end{center}






\newpage
\subsection{Finding contours of grains from SEM image}
\newexo{language basics, numpy, image, matplotlib}{1-hour}{Use numpy for manipulating images}{grains.py}

The objective is to use numpy for facilitating object detection. Here
the object to detect are grains that appear on a SEM image. The related SEM
image is here.


\begin{center}
  \includegraphics[width=8cm]{img/grains.png}
\end{center}



\begin{task}
  Download the image file \dl{grains.tif} and place it on your current python working directory.
\end{task}

\begin{task}
  As shown in the previous exercise, open the image with the
  \texttt{mpimg} module that comes from \texttt{matplotlib.image} and
  plot it with the \texttt{imshow} function.
\end{task}

\begin{task}
  Use the slicing to crop the image for removing the information banner at the bottom of the image.
\end{task}

\begin{task}
  Apply thresholds to highlight grains. You should obtain something like this :
  \begin{center}
    \includegraphics[width=9cm]{img/grains-1.png}
  \end{center}
\end{task}


\begin{task}
  Apply the \texttt{np.gradient} to highlight grain contours. Apply a
  threshold and you should obtain something like this :
  \begin{center}
    \includegraphics[width=9cm]{img/grains-2.png}
  \end{center}
\end{task}




\newpage
\subsection{Ball tracking}
\newexo{language basics, numpy, scipy, matplotlib}{3 hours}{}{magnus/magnus.py}

The objective of this practical exercise it to implement several layer
of numerical treatment in order to track a moving object on a video.
The original video is available here:
\url{https://www.youtube.com/watch?v=r-i6XpcL1Fs}

\begin{center}
  \includegraphics[width=.6\linewidth]{magnus}
\end{center}

\begin{task}
  Download the image series \url{http://www.unilim.fr/pages_perso/damien.andre/cours/python/magnus-img.zip} and place it on your current python working directory.
\end{task}

\begin{task}
  Thanks to the \texttt{glob} module, display one-by-one the name of the
  image files inside the \texttt{magnus-img} directory.
\end{task}

\begin{task}
  Open each image with the \texttt{mpimg.imread()} function from the \texttt{matplotlib} module
  and convert them into gray-scale.
\end{task}

\begin{task}
  Save the gray-scale images into another directory named
  \texttt{modified-img} thanks to the \texttt{scipy.misc.toimage()} function.
\end{task}

Now, let's play! 

\begin{task}
  Imagine several numerical treatments able to track the position (in
  pixel) of the falling ball. 
\end{task}

You should obtain something like this video: \url{http://www.unilim.fr/pages_perso/damien.andre/cours/python/magnus-result.mp4}




\newpage
\subsection{A full Python tuner \twonotes}
\newexo{language basics, numpy, scipy, matplotlib}{1-2 hours}{Detect the main note from a \texttt{*.wav} music file}{tuner/tuner.py}

The objective of this training exercise it to use Python for detecting
the main musical note of an instrument. To make it easier, the sounds
are embedded in \texttt{*.wav} files. First, you need to download the following archive
\url{http://www.unilim.fr/pages_perso/damien.andre/cours/python/wav-file.zip}
that contains several music file in the raw \texttt{*.wav} format and
unzip it.

\begin{task}
  open one of these file thanks to the \keyw{wavfile}
  function that comes from the \keyw{scipy.io} module. 
\end{task}


\begin{task}
  put the collected signal into a numpy array. Note that you must
  manage two cases: stereo wave file or mono wave file.
\end{task}


\begin{task}
  plot the obtained temporal signal versus time. 
\end{task}

\noindent At this step, you must obtain something like this:
\begin{center}
  \includegraphics[width=0.6\linewidth]{temp-signal}
\end{center}


% \noindent Please copy/paste the following code that computes the power
% spectral density of the temporal signal:\vspace*{-1\baselineskip}
% \begin{lstlisting}
% # spectral analysis: computing the power spectral density 
% yf = np.fft.fft(signal)
% N = len(signal)
% T = 1./rate                   # the period of data
% psd  = (T/N) * np.abs(yf)**2  # compute power spectral density 
% frq = np.fft.fftfreq(N, d=T)  # and the related frequencies
% frq = frq[:int(N/2)] # remove negative frequencies
% psd = psd[:int(N/2)] # and the related values of psd
% \end{lstlisting}


\begin{task}
  thanks to the \keyw{np.fft.fft()} and \keyw{np.fft.fftfreq()}
  functions, make a spectral analysis of this temporal signal. 
\end{task}

\begin{task}
  compute the absolute value of the given fft and plot the spectral signal versus frequencies. 
\end{task}

\noindent At this step, you must obtain the following chart:
\begin{center}
  \includegraphics[width=0.6\linewidth]{fft-signal}
\end{center}


\begin{task}
  compute the main frequency of the spectral signal. It corresponds
  to the frequency where the fft is maximal. Note that you can use the
  \keyw{argmax()} method of numpy array,
\end{task}

\noindent Copy and paste the following code that corresponds to the
frequencies of musical notes with their related names. If you
experienced some problem with copy/paste, you can download directly
this file from
\dl{tuner/notes.py}.
\vspace*{-1\baselineskip}
\begin{lstlisting}
# frequencies of notes, these values were extracted 
# from https://fr.wikipedia.org/wiki/Note_de_musique
note_f = np.array([32.70, 65.41,  130.81, 261.63, 523.25, 1046.50, 2093.00, 4186.01,
                   34.65, 69.30,  138.59, 277.18, 554.37, 1108.73, 2217.46, 4434.92,
                   36.71, 73.42,  146.83, 293.66, 587.33, 1174.66, 2349.32, 4698.64,
                   38.89, 77.78,  155.56, 311.13, 622.25, 1244.51, 2489.02, 4978.03,
                   41.20, 82.41,  164.81, 329.63, 659.26, 1318.51, 2637.02, 5274.04,
                   43.65, 87.31,  174.61, 349.23, 698.46, 1396.91, 2793.83, 5587.65,
                   46.25, 92.50,  185.00, 369.99, 739.99, 1479.98, 2959.96, 5919.91,
                   49.00, 98.00,  196.00, 392.00, 783.99, 1567.98, 3135.96, 6271.93,
                   51.91, 103.83, 207.65, 415.30, 830.61, 1661.22, 3322.44, 6644.88,
                   55.00, 110.00, 220.00, 440.00, 880.00, 1760.00, 3520.00, 7040.00,
                   58.27, 116.54, 233.08, 466.16, 932.33, 1864.66, 3729.31, 7458.62,
                   61.74, 123.47, 246.94, 493.88, 987.77, 1975.53, 3951.07, 7902.00])

# names of each note in the above array
note_id = ['C ', 'C ', 'C ', 'C ', 'C ', 'C ', 'C ', 'C ',
           'C#', 'C#', 'C#', 'C#', 'C#', 'C#', 'C#', 'C#',
           'D ', 'D ', 'D ', 'D ', 'D ', 'D ', 'D ', 'D ', 
           'D#', 'D#', 'D#', 'D#', 'D#', 'D#', 'D#', 'D#',  
           'E ', 'E ', 'E ', 'E ', 'E ', 'E ', 'E ', 'E ', 
           'F ', 'F ', 'F ', 'F ', 'F ', 'F ', 'F ', 'F ', 
           'F#', 'F#', 'F#', 'F#', 'F#', 'F#', 'F#', 'F#', 
           'G ', 'G ', 'G ', 'G ', 'G ', 'G ', 'G ', 'G ', 
           'G#', 'G#', 'G#', 'G#', 'G#', 'G#', 'G#', 'G#', 
           'A ', 'A ', 'A ', 'A ', 'A ', 'A ', 'A ', 'A ', 
           'A#', 'A#', 'A#', 'A#', 'A#', 'A#', 'A#', 'A#', 
           'B ', 'B ', 'B ', 'B ', 'B ', 'B ', 'B ', 'B ']
\end{lstlisting}



\begin{task}
  compute the index of the closest frequency (indexed by the \keyw{note\_f} array) of the main frequency.
\end{task}

\begin{task}
  deduce the name of the closest note. Thanks to the \keyw{print()}
  function, display the name of this note and the difference in Hertz
  from this note. The given output must looks like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
Analyzing 'sample1.wav'... Closest note is 'C ' with a difference of 0.16 Hz
\end{lstlisting}
\end{task}

This exercise is over, however, if you want to improve this program
you may:
\begin{enumerate}
\item implement command line option with the \keyw{argparse} module to
  specify the name of the wav file at the execution of your script.
\item use the \keyw{pyaudio} module to record the sound through a
  microphone and for deducing on-the-fly the related note.
\end{enumerate}




\newpage
\subsection{Post treating digital image correlation results}
\newexo{language basics, material mechanics, images, numpy, scipy, matplotlib}{2-4 hours}{Computing Young's modulus from displacement field given by DIC}{dic/dic.py}

The aim of this exercise is to compute a material property (Young's
modulus) from a Digital Image Correlation (DIC) processing. The DIC is
an advanced numerical treatment able to retrieve a displacement field
by comparing two images. Here, DIC is used on four point bending test. 

The image below shows the apparatus. The force $F$ is applied through
cylindrical rods. The sample is a rectangular beam rod with section lengths
$b$ and $h$. Image snapshots were taken during the test.
\begin{center}
  \svgb{\linewidth}{./img/dic.pdf_tex}
\end{center}

The different parameter values of the experiment are given in the following tab:\\
\begin{center}
  \begin{tabular}{clll}
    $im$  & \texttt{(2560, 1920)}     & image size                 & $px$ \\
    $s$   & \texttt{6.1e-06}          & image scale                & $m.px^{-1}$\\
    $L$   & \texttt{36e-3}            & distance of upper supports & $m$ \\
    $l$   & \texttt{14e-3}            & distance of lower supports & $m$ \\
    $b$   & \texttt{7.66e-3}          & sample width               & $m$ \\
    $h$   & \texttt{4.06e-3}          & sample height              & $m$ \\
    $F$   & \texttt{400.}             & the applied force          & $N$ \\
    $M_f$ & $\frac{F}{4}\times(L-l)$  & the applied torque         & $N.m$ \\
    $I$   & $\frac{b h^3}{12}$        & quadratic section momentum         & $m^4$
  \end{tabular}
\end{center}

The images were analyzed with a DIC treatment. The following picture
highlight this treatment. A point grid is introduced in the zone of
interest. Finally, displacement of each point is computed thanks to
DIC numerical treatments.
\begin{center}
  \includegraphics[width=0.6\linewidth]{dic-marker}
\end{center}

Download the file \dl{dic/dic.csv} that contains the result of this
DIC process. The file looks like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
index,index_x,index_y,pos_x,pos_y,disp_x,disp_y
0,0,0,103.0,604.0,0.939903259277,-2.02941894531
1,0,1,103.0,624.0,0.897819519043,-1.99945068359
2,0,2,103.0,644.0,0.843704223633,-2.00439453125
3,0,3,103.0,664.0,0.777610778809,-1.98834228516
.....
\end{lstlisting}
In the above file, columns are separated by comma characters. The
first column is the global index of the data. The second and third columns
are the $x$, $y$ indexes of the related data. The following picture highlights the
numeration convention: the first number is the global \textit{index},
the second and third number are \textit{index\_x} and
\textit{index\_y}.
\begin{center}
  \svgb{0.2\linewidth}{./img/grid.pdf_tex}
\end{center}

The columns \textit{pos\_x} and \textit{pos\_y} give the coordinates
in pixel of the related point. Finally, the \textit{disp\_x} and \textit{disp\_y}
values are the displacement vector of this point.

\begin{task}
  read this file and store the \textit{pos\_x}, \textit{pos\_y},
  \textit{disp\_x} and \textit{disp\_y} values in two dimensional
  arrays where values are indexed by \textit{index\_x} and
  \textit{index\_y}. Note that the point grid size is 116$\times$30.
  Your code must look like:
\vspace*{-1\baselineskip}
\begin{lstlisting}
pos_x  = np.zeros((116, 30))
pos_y  = np.zeros((116, 30))
disp_x = np.zeros((116, 30))
disp_y = np.zeros((116, 30))
with open('./dic.csv', 'r') as f:
  # read file and fill arrays....
 \end{lstlisting}
\end{task}


\begin{task}
  translate these values from pixel to meter. The related scale factor is:
  \begin{equation}
s=6.1\times10^{-6}\ \text{m}.\text{px}^{-1}\nonumber
\end{equation}
\end{task}



\begin{task}
  Thanks to the matplotlib \keyw{quiver()} function, plots the
  displacement field with graphical arrows.
\end{task}
Your given plot must look like:
\begin{center}
  \includegraphics[width=1.\linewidth]{./img/disp-field}
\end{center}

From the given displacement field, we want to compute the strain
field. Remember that strain field is the gradient of the displacement
field.

\begin{task}
  thanks to the numpy \keyw{gradient()} function, computes the strain
  field $\varepsilon_{xx}$. The $\varepsilon_{xx}$ strain is given by
  the relation:
  \begin{equation}
\varepsilon_{xx}= \left[\vec{grad}\left(\vec{u}.\vec{x}\right)\right].\vec{x}
\end{equation}
where $u$ is the displacement vector.
\end{task}

\begin{task}
  thanks to the matplotlib \keyw{contourf()} function, plots the
  $\varepsilon_{xx}$ strain field.
\end{task}
Your plot must look like:
\begin{center}
  \includegraphics[width=1.\linewidth]{./img/strain-field}
\end{center}

Now, we want to compute the Young's modulus of this material.
As you can see, the above plot is really noisy. In this condition, we are
not able to compute the Young's modulus of this material from this raw data.


To compute the young's modulus, we propose to use the following
relation that comes from material strength theory:
\begin{equation}
  E = -\frac{M_f}{f''(x)\times I} \label{eq:fpp}
\end{equation}
where $f''(x)$ is the second derivative order of the deviation
(displacement along $y$) of the neutral fiber of the
beam. 

\begin{task}
  from the displacement array along $y$ (in the \keyw{disp\_y} array) extract the deviation of the
  neutral fiber versus the position along $x$ (in the \keyw{pos\_x} array).
\end{task}


\begin{task}
  thanks to the \keyw{curve\_fit()} function that comes from \keyw{scipy.optimize}, 
  compute a second order fitting function $f$ of the deviation where $f$ is:
\begin{equation}
  f(x) = a x^2 + b x + c
\end{equation}
\end{task}


\begin{task}
  plot the raw data and the fitted function of deviation versus the position $x$.
\end{task}
Your plot must look like:
\begin{center}
  \includegraphics[width=1.\linewidth]{./img/dev}
\end{center}


\begin{task}
  thanks to equation \ref{eq:fpp}, compute the Young's modulus of the material. 
\end{task}

Compare your result with literature. The material tested here is a
\textit{duralumin } rod.



\newpage
\subsection{Discrete element from scratch}
\newexo{language basics, object oriented programming, dem method}{4 hours}{Build a mini 2D DEM program for compaction problem}{dem/run-dem.py}

The aim of this exercise is to build from scratch a mini discrete
element program able to study compaction problems. Before starting, you
probably need to learn a little bit about Discrete Element Method
(DEM).


\begin{task}
  download the \dl{dem/minidem.py} file, that contains some utility for DEM visualization and management.
\end{task}


\begin{task}
  create a new python file and import the \keyw{minidem.py} file as a module.
\end{task}


\begin{task}
  define a new class named \keyw{grain}. This class must have the
  following attributes: a radius, a mass, a position vector, a
  velocity vector and an acceleration vector. Note that you can use
  the \keyw{minidem.vec} class for vectors.
\end{task}

Note that the dimension of the scene is a square of 100x100 lengths. 


\begin{task}
  copy/paste the following code in your python file. Use it for
  building a discrete domain with 9x9 discrete elements aligned on a
  regular grid. The discrete elements must have a radius of 5 and a
  mass equal to 1.  \vspace*{-1\baselineskip}
\begin{lstlisting}
  def time_loop():
    pass

dem.init()
dem.loop_function = time_loop
dem.max_iteration = 1000

# build your domain here

dem.run()
\end{lstlisting}
\end{task}



\begin{task}
  thanks to the \keyw{random} module add some randomization for 
  discrete element sizes and locations.
\end{task}

The time loop of a discrete element algorithm must contains the following
mains steps. For all discrete elements:
\begin{enumerate}
\item set forces to zero,
\item add gravity forces ,
\item detect contact and add repulsive force if a contact is detected,
\item compute position at the next time step thanks to the velocity Verlet scheme and
\item apply boundary condition.
\end{enumerate}


\begin{task}
  implement the step 1, 2 and 4. Check your implementation by running
  your code. All the discrete element must fall down.
\end{task}


\begin{task}
  apply boundary conditions for constraining grains to stay inside the 100x100 scene.
  You can apply a reflection law with a \textit{coefficient of restitution} around 0.9.
  It means that a discrete element will have a velocity 10\% lower after a collision with a wall.
\end{task}

\begin{task}
  build a new \keyw{collide} function that takes two discrete elements
  as argument. If a collision is detected between the two discrete
  elements, the \keyw{collide} function computes and applies repulsive
  forces on both discrete elements.  The repulsive force $\mathbf{f}$
  must be:
  \begin{equation}
    \mathbf{f} = K.\delta.\mathbf{n} \nonumber
  \end{equation}
  where $K$ is the contact stiffness (around 10,000), $\delta$ is the
  interpenetration and $\mathbf{n}$ is the contact normal.
\end{task}


\begin{task}
  in order to stabilize the simulation, add a damping force to the
  repulsive force in the \keyw{collide} function. The damping force
  $\mathbf{f_d}$ is:
  \begin{equation}
    \mathbf{f_d} = d . \delta_v . \mathbf{n}
  \end{equation}
  where $d$ is the damping factor (around 14.1), $\delta_v$ is the
  norm of the velocity difference between the two discrete elements
  and $\mathbf{n}$ is the contact normal.
\end{task}

Now, you can play with a minimal discrete element code able to study
the 2D packing of arbitrary disks. Note that this problem is an open
problem of the granular media science. At this time, it can not
be solved by analytic laws!


\section{Conclusion}
Now, you have the basics of Python programming for scientific
stuffs. With only basics, you are able to do sophisticated things such
as command line software or advanced numerical treatments and
computation.

You probably want to build nice Graphical User Interface (GUI) with
Python. Be aware, my advice is: do a GUI only if this is really
required.  Programming GUI, even in Python, is a very fastidious and
frustrating stuff. Graphical programs are more than ten times longer
that command line programs for doing the same job. Therefore, if you
really need GUI, you can choose several packages such as
\keyw{tkinter} or \keyw{pyQt}.


The next part of this document will focus on usage of Python for
studying and solving a special field. So, let's move on a very interesting topic
concerning Artificial Intelligence (AI).


Never forget forget that \textbf{programming is fun}!
